#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y

#include "..\Direct2D.au3"
#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


Global $oRender, $oBuffer_Bmp
_Example()


Func _Example()
	Local $hGui = GUICreate("Direct2D", 400, 300)

	Local $oFactory = _D2D_Factory_Create()
	$oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 1, 1, 0)

	Local $tDashes = DllStructCreate("float Val[4];")
	$tDashes.Val(1) = 1 ; length of first dash
	$tDashes.Val(2) = 2 ; length of first space
	$tDashes.Val(3) = 3 ; length of second dash
	$tDashes.Val(4) = 2 ; length of second space
	Local $oStroke = _D2D_Factory_CreateStrokeStyle($oFactory, 0, 10, 0, 0, $D2D1_CAP_STYLE_ROUND, $D2D1_DASH_STYLE_CUSTOM, 0, $tDashes, 4)

	Local $oBuffer = _D2D_RenderTarget_CreateCompatibleRenderTarget($oRender)
	$oBuffer_Bmp = _D2D_BitmapRenderTarget_GetBitmap($oBuffer)


	Local $tRect = _D2D1_RECT_F(50, 50, 350, 250)

	$oBuffer.BeginDraw()
	$oBuffer.Clear(_D2D1_COLOR_F(0, 0, 0.3))
	$oBrush.SetColor(_D2D1_COLOR_F(0, 0.3, 0))
	$oBuffer.FillRectangle($tRect, $oBrush)
	$oBrush.SetColor(_D2D1_COLOR_F(1, 1, 0))
	$oBuffer.DrawRectangle($tRect, $oBrush, 4, $oStroke)
	$oBuffer.EndDraw(0, 0)

	GUIRegisterMsg($WM_PAINT, "_WM_PAINT")
	GUIRegisterMsg($WM_ERASEBKGND, "_WM_ERASEBKGND")
	GUISetState()


	While GUIGetMsg() <> -3
	WEnd

	$oStroke = 0
	$oBrush = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example

Func _WM_ERASEBKGND($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam, $lParam
	$oRender.BeginDraw()
	$oRender.DrawBitmap($oBuffer_Bmp, Null, 1, 0, Null)
	$oRender.EndDraw(0, 0)
	Return 0
EndFunc   ;==>_WM_ERASEBKGND

Func _WM_PAINT($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam, $lParam
	$oRender.BeginDraw()
	$oRender.DrawBitmap($oBuffer_Bmp, Null, 1, 0, Null)
	$oRender.EndDraw(0, 0)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_WM_PAINT
