#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()



Func _Example()

	Local $hGui = GUICreate("Direct2D", 600, 400)

	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)

	Local $aStop[4] = [3]
	$aStop[1] = _D2D1_GRADIENT_STOP(0, 1)          ;Position = 0,   Red = 1, [Green = 0,  Blue = 0,  Alpha = 1]
	$aStop[2] = _D2D1_GRADIENT_STOP(0.5, 0, 1)     ;Position = 0.5, Red = 0,  Green = 1, [Blue = 0,  Alpha = 1]
	$aStop[3] = _D2D1_GRADIENT_STOP(1, 0, 0, 1, 0) ;Position = 1,   Red = 0,  Green = 0,  Blue = 1,  Alpha = 0


	Local $oStopCollection = _D2D_RenderTarget_CreateGradientStopCollection($oRender, $aStop)
	Local $oBrush_Radial = _D2D_RenderTarget_CreateRadialGradientBrush($oRender, $oStopCollection, 150, 300, 100, 80)
	Local $oBrush_Linear = _D2D_RenderTarget_CreateLinearGradientBrush($oRender, $oStopCollection, 20, 20, 280, 180)

	GUISetState()


	$oRender.BeginDraw()

	_D2D_RenderTarget_FillRectangle($oRender, 20, 20, 280, 180, $oBrush_Linear)

	$oBrush_Linear.SetStartPoint(_D2D1_POINT_2F(320, 20))
	$oBrush_Linear.SetEndPoint(_D2D1_POINT_2F(580, 180))
	$oRender.FillRectangle(_D2D1_RECT_F(320, 20, 580, 180), $oBrush_Linear)



	_D2D_RenderTarget_FillEllipse($oRender, 150, 300, 100, 80, $oBrush_Radial)

	$oBrush_Radial.SetCenter(_D2D1_POINT_2F(450, 300))
	$oBrush_Radial.SetRadiusX(80)
	$oBrush_Radial.SetRadiusY(100)
	$oBrush_Radial.SetGradientOriginOffset(_D2D1_POINT_2F(-15, -30))
	$oRender.FillEllipse(_D2D1_ELLIPSE(450, 300, 80, 100), $oBrush_Radial)


	$oRender.EndDraw(0, 0)


	While GUIGetMsg() <> -3
	WEnd

	$oStopCollection = 0
	$oBrush_Radial = 0
	$oBrush_Linear = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
