#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D_1.au3"
#include "..\WIC.au3"
#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>


Global $oWIC_ImagingFactory = _WIC_ImagingFactory_Create()

Global $sFile = FileOpenDialog("open imagefile", @ScriptDir & "\", "Images (*.png;*.jpg;*.bmp;*.gif;*.tif)", 1)
Global $oWIC_BitmapDecoder = _WIC_ImagingFactory_CreateDecoderFromFilename($oWIC_ImagingFactory, $sFile)
If @error Then Exit MsgBox(0, "Error", _D2D_ErrorMessage(@error))

Global $oWIC_Bitmap = _WIC_BitmapDecoder_GetFrame($oWIC_BitmapDecoder)
Global $oWIC_FormatConverter = _WIC_ImagingFactory_CreateFormatConverter($oWIC_ImagingFactory)
$oWIC_FormatConverter.Initialize($oWIC_Bitmap, _WinAPI_GUIDFromString($sGUID_WICPixelFormat32bppPBGRA), 0, 0, 0, 1)

Global $iImgW, $iImgH
$oWIC_FormatConverter.GetSize($iImgW, $iImgH)


Global $iGui_W = $iImgW
Global $iGui_H = $iImgH
Global $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)
GUISetState()


Global $oD2D_Factory = _D2D_Factory1_Create()

Global $oD2D_DeviceContext, $oD2D_SwapChain
_D2D_CreateHWNDContext($oD2D_Factory, $hGui, $oD2D_DeviceContext, $oD2D_SwapChain)
If @error Then Exit MsgBox(0, "Error", _D2D_ErrorMessage(@error) & @CRLF & "You need Win8 or Win7+PlatformUpdate to run this example")

Global $oD2D_Bitmap = _D2D_RenderTarget_CreateBitmapFromWicBitmap($oD2D_DeviceContext, $oWIC_FormatConverter)


Global $oD2D_GaussianBlurEffect = _D2D_DeviceContext_CreateEffect($oD2D_DeviceContext, $sIID_D2D1GaussianBlur)

_D2D_Effect_SetInput($oD2D_GaussianBlurEffect, $oD2D_Bitmap)
;Or => $oD2D_GaussianBlurEffect.SetInput(0, $oD2D_Bitmap, False)

_D2D_Properties_SetValue($oD2D_GaussianBlurEffect, $D2D1_GAUSSIANBLUR_PROP_STANDARD_DEVIATION, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_Float(6))
;Or => $oD2D_GaussianBlurEffect.SetValue($D2D1_GAUSSIANBLUR_PROP_STANDARD_DEVIATION, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_Float(6), _D2D1_SizeOf("float"))


Global $oD2D_EffectOut = _D2D_Effect_GetOutput($oD2D_GaussianBlurEffect)


Global $iTimer = TimerInit(), $bDraw = False
While GUIGetMsg() <> -3
	If TimerDiff($iTimer) > 500 Then
		$iTimer = TimerInit()
		$oD2D_DeviceContext.BeginDraw()
		$oD2D_DeviceContext.Clear(_D2D1_Color_F(0, 0, 0, 1))
		Switch $bDraw
			Case False
				$oD2D_DeviceContext.DrawImage($oD2D_Bitmap, Null, Null, $D2D1_INTERPOLATION_MODE_CUBIC, $D2D1_COMPOSITE_MODE_SOURCE_OVER)
			Case Else
				$oD2D_DeviceContext.DrawImage($oD2D_EffectOut, Null, Null, $D2D1_INTERPOLATION_MODE_CUBIC, $D2D1_COMPOSITE_MODE_SOURCE_OVER)
		EndSwitch
		$oD2D_DeviceContext.EndDraw(0, 0)
		$oD2D_SwapChain.Present(1, 0)
		$bDraw = Not $bDraw
	EndIf
WEnd
