#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()
	Local $hGui = GUICreate("Direct2D", 400, 300)
	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 1, 1, 0)
	Local $oStroke = _D2D_Factory_CreateStrokeStyle($oFactory, 0, 0, $D2D1_CAP_STYLE_ROUND, $D2D1_CAP_STYLE_TRIANGLE)
	GUISetState()

	$oRender.BeginDraw()

	_D2D_RenderTarget_DrawLine($oRender, 100, 100, 300, 100, $oBrush, 60, $oStroke)

	$oRender.DrawLine(_D2D1_POINT_2F(100, 200), _D2D1_POINT_2F(300, 200), $oBrush, 60, $oStroke)

	Local $iHresult = $oRender.EndDraw(0, 0)
	ConsoleWrite("> EndDraw: " & _D2D_ErrorMessage($iHresult) & @CRLF)

	While GUIGetMsg() <> -3
	WEnd

	$oStroke = 0
	$oBrush = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
