#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
#AutoIt3Wrapper_UseX64 = y
Opt("GUIOnEventMode", 1)

#include <..\Direct2D_1.au3>
#include <..\WIC.au3>
#include <WindowsConstants.au3>
#include <GUIConstantsEx.au3>

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


Global $oWIC_ImagingFactory = _WIC_ImagingFactory_Create()
Global $oWIC_BitmapDecoder = _WIC_ImagingFactory_CreateDecoderFromFilename($oWIC_ImagingFactory, @ScriptDir & "\mandrill.jpg")
If @error Then Exit MsgBox(0, "Error", _D2D_ErrorMessage(@error))


Global $oWIC_Bitmap = _WIC_BitmapDecoder_GetFrame($oWIC_BitmapDecoder)
Global $oWIC_FormatConverter = _WIC_ImagingFactory_CreateFormatConverter($oWIC_ImagingFactory)
$oWIC_FormatConverter.Initialize($oWIC_Bitmap, _WinAPI_GUIDFromString($sGUID_WICPixelFormat32bppPBGRA), 0, Null, 0.0, 0)


Global $iImgW, $iImgH
$oWIC_FormatConverter.GetSize($iImgW, $iImgH)

Global $iGui_W = $iImgW
Global $iGui_H = $iImgH

Global $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

Global $oD2D_Factory = _D2D_Factory1_Create()
Global $oD2D_DeviceContext, $oID3D11SwapChain
_D2D_CreateHWNDContext($oD2D_Factory, $hGui, $oD2D_DeviceContext, $oID3D11SwapChain)
If @error Then Exit MsgBox(0, "Error", _D2D_ErrorMessage(@error) & @CRLF & "You need Win8 or Win7+PlatformUpdate to run this example")


Global $oD2D_Bitmap = _D2D_RenderTarget_CreateBitmapFromWicBitmap($oD2D_DeviceContext, $oWIC_FormatConverter)

Global $oD2D_PerspectiveTransformEffect = _D2D_DeviceContext_CreateEffect($oD2D_DeviceContext, $sIID_D2D13DPerspectiveTransform)
$oD2D_PerspectiveTransformEffect.SetInput(0, $oD2D_Bitmap, True)

$oD2D_PerspectiveTransformEffect.SetValue($D2D1_3DPERSPECTIVETRANSFORM_PROP_PERSPECTIVE_ORIGIN, $D2D1_PROPERTY_TYPE_VECTOR2, _D2D1_VECTOR_2F($iImgW * 0.5, $iImgH * 0.5), _D2D1_SIZEOF($tagD2D1_VECTOR_2F))
$oD2D_PerspectiveTransformEffect.SetValue($D2D1_3DPERSPECTIVETRANSFORM_PROP_ROTATION_ORIGIN, $D2D1_PROPERTY_TYPE_VECTOR3, _D2D1_VECTOR_3F($iImgW * 0.5, $iImgH * 0.5), _D2D1_SIZEOF($tagD2D1_VECTOR_3F))
$oD2D_PerspectiveTransformEffect.SetValue($D2D1_3DPERSPECTIVETRANSFORM_PROP_INTERPOLATION_MODE, $D2D1_PROPERTY_TYPE_ENUM, _D2D1_UINT($D2D1_3DPERSPECTIVETRANSFORM_INTERPOLATION_MODE_MULTI_SAMPLE_LINEAR), _D2D1_SIZEOF("uint"))

Global $pOutPut
$oD2D_PerspectiveTransformEffect.GetOutput($pOutPut)



Global $fRot_X, $fRot_Y, $fRot_Z



Global $hChild = GUICreate("Cntrl", 320, 170, 10, 10, -1, -1, $hGui)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

GUICtrlCreateLabel("Rotation X:", 10, 30, 70, 20, BitOR(0x0200, 0x0002))
Global $cSlider_X = GUICtrlCreateSlider(100, 30, 200, 30)
GUICtrlSetLimit(-1, 360, 0)
GUICtrlSetOnEvent(-1, "_Rotate")
Global $hSlider_X = GUICtrlGetHandle($cSlider_X)

GUICtrlCreateLabel("Rotation Y:", 10, 70, 70, 20, BitOR(0x0200, 0x0002))
Global $cSlider_Y = GUICtrlCreateSlider(100, 70, 200, 30)
GUICtrlSetLimit(-1, 360, 0)
Global $hSlider_Y = GUICtrlGetHandle($cSlider_Y)

GUICtrlCreateLabel("Rotation Z:", 10, 110, 70, 20, BitOR(0x0200, 0x0002))
Global $cSlider_Z = GUICtrlCreateSlider(100, 110, 200, 30)
GUICtrlSetLimit(-1, 360, 0)
Global $hSlider_Z = GUICtrlGetHandle($cSlider_Z)

GUIRegisterMsg($WM_HSCROLL, "WM_HSCROLL")

GUISetState(@SW_SHOW, $hGui)
GUISetState(@SW_SHOW, $hChild)



_Draw()

While Sleep(100)
WEnd




Func _Rotate()
	Local $iPos = GUICtrlRead(@GUI_CtrlId)
	Switch @GUI_CtrlId
		Case $cSlider_X
			$fRot_X = $iPos
			_Draw()
		Case $cSlider_Y
			$fRot_Y = $iPos
			_Draw()
		Case $cSlider_Z
			$fRot_Z = $iPos
			_Draw()
	EndSwitch
EndFunc   ;==>_Rotate



Func WM_HSCROLL($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg, $wParam, $lParam

	Local $iCode = BitAND($wParam, 0x0000FFFF)
	Local $iPos = BitShift($wParam, 16)

	Switch $hWnd
		Case $hChild
			If $iCode = 5 Then
				Switch $lParam
					Case $hSlider_X
						$fRot_X = $iPos
						_Draw()
					Case $hSlider_Y
						$fRot_Y = $iPos
						_Draw()
					Case $hSlider_Z
						$fRot_Z = $iPos
						_Draw()
				EndSwitch
			EndIf
	EndSwitch

	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_HSCROLL



Func _Draw()
	$oD2D_PerspectiveTransformEffect.SetValue($D2D1_3DPERSPECTIVETRANSFORM_PROP_ROTATION, $D2D1_PROPERTY_TYPE_VECTOR3, _D2D1_VECTOR_3F($fRot_X, $fRot_Y, $fRot_Z), _D2D1_SIZEOF($tagD2D1_VECTOR_3F))

	$oD2D_DeviceContext.BeginDraw()
	$oD2D_DeviceContext.Clear(_D2D1_COLOR_F(0, 0, 0, 1))
	_D2D_DeviceContext_DrawImage($oD2D_DeviceContext, $pOutPut)
	;Or => $oD2D_DeviceContext.DrawImage($pOutPut, Null, Null, $D2D1_INTERPOLATION_MODE_CUBIC, $D2D1_COMPOSITE_MODE_SOURCE_OVER)

	$oD2D_DeviceContext.EndDraw(0, 0)
	$oID3D11SwapChain.Present(1, 0)
EndFunc   ;==>_Draw



Func _Exit()
	$oD2D_Bitmap = 0
	$oD2D_PerspectiveTransformEffect = 0

	$oWIC_Bitmap = 0
	$oWIC_BitmapDecoder = 0
	$oWIC_FormatConverter = 0
	$oWIC_ImagingFactory = 0

	$oID3D11SwapChain = 0
	$oD2D_DeviceContext = 0
	$oD2D_Factory = 0

	GUIDelete($hGui)
	Exit
EndFunc   ;==>_Exit
