#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = n
#include "..\Direct2D_1.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


Global $iGui_W = 800
Global $iGui_H = 600

Global $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)

Global $oFactory = _D2D_Factory1_Create()
Global $oContext
Global $oSwapChain
_D2D_CreateHWNDContext($oFactory, $hGui, $oContext, $oSwapChain)
If @error Then Exit MsgBox(0, "Error", _D2D_ErrorMessage(@error) & @CRLF & "You need Win8 or Win7+PlatformUpdate to run this example")


Global $oFX_Turbulence = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1Turbulence)
_D2D_Properties_SetValue($oFX_Turbulence, $D2D1_TURBULENCE_PROP_SIZE, $D2D1_PROPERTY_TYPE_VECTOR2, _D2D1_VECTOR_2F($iGui_W, $iGui_H))
_D2D_Properties_SetValue($oFX_Turbulence, $D2D1_TURBULENCE_PROP_NUM_OCTAVES, $D2D1_PROPERTY_TYPE_UINT32, _D2D1_UINT(8))

Global $oOutPut = _D2D_Effect_GetOutput($oFX_Turbulence)
Global $oImgBrush = _D2D_DeviceContext_CreateImageBrush($oContext, $oOutPut, 0, 0, $iGui_W, $iGui_H)

GUISetState()


$oContext.BeginDraw()
$oContext.Clear(_D2D1_COLOR_F())
$oContext.FillRectangle(_D2D1_RECT_F(0, 0, $iGui_W, $iGui_H), $oImgBrush)
$oContext.EndDraw(0, 0)
$oSwapChain.Present(1, 0)


While GUIGetMsg() <> -3
WEnd

$oImgBrush = 0
$oFX_Turbulence = 0

$oSwapChain = 0
$oContext = 0
$oFactory = 0

GUIDelete($hGui)