#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc

Global Const $STM_SETIMAGE = 0x0172

Global $iGui_W = 640
Global $iGui_H = 240
Global $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)
Global $cPic = GUICtrlCreatePic("", 10, 10, $iGui_W - 20, $iGui_H - 20)
GUISetState()

Global $hHBMP = _CreateHBitmap($cPic)
GUICtrlSendMsg($cPic, $STM_SETIMAGE, $IMAGE_BITMAP, $hHBMP)



While GUIGetMsg() <> -3
WEnd




Func _CreateHBitmap($cCtrl)
	Local $hCtrl = GUICtrlGetHandle($cCtrl)
	Local $tRect = _WinAPI_GetClientRect($hCtrl)
	Local $iW = $tRect.Right - $tRect.Left
	Local $iH = $tRect.Bottom - $tRect.Top

	Local $hDC = _WinAPI_GetDC($hCtrl)
	Local $hCDC = _WinAPI_CreateCompatibleDC($hDC)
	Local $hHBMP = _WinAPI_CreateCompatibleBitmap($hDC, $iW, $iH)
	Local $hObj = _WinAPI_SelectObject($hCDC, $hHBMP)



	Local $oFactory = _D2D_Factory_Create()
	Local $oDC_Render = _D2D_Factory_CreateDCRenderTarget($oFactory)
	Local $iHResult = $oDC_Render.BindDC($hCDC, $tRect)
	ConsoleWrite("> BindDC: " & _D2D_ErrorMessage($iHResult) & @CRLF)

	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oDC_Render, 1, 1, 0)
	Local $tEllipse = _D2D1_ELLIPSE($iW * 0.5, $iH * 0.5, $iW * 0.4, $iH * 0.3)

	$oDC_Render.BeginDraw()
	$oDC_Render.Clear(_D2D1_COLOR_F(0, 0, 0.3))
	$oBrush.SetColor(_D2D1_COLOR_F(0, 0.3, 0))
	$oDC_Render.FillEllipse($tEllipse, $oBrush)
	$oBrush.SetColor(_D2D1_COLOR_F(1, 1, 0))
	$oDC_Render.DrawEllipse($tEllipse, $oBrush, 8, 0)
	$iHResult = $oDC_Render.EndDraw(0, 0)
	ConsoleWrite("> Drawing to DC: " & _D2D_ErrorMessage($iHResult) & @CRLF)


	_WinAPI_SelectObject($hCDC, $hObj)
	_WinAPI_DeleteDC($hCDC)
	_WinAPI_ReleaseDC($hCtrl, $hDC)
	Return $hHBMP
EndFunc   ;==>_CreateHBitmap