#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()



Func _Example()

	Local $hGui = GUICreate("Direct2D", 600, 400)

	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 1, 1, 0)

	GUISetState()


	Local $oPath = _D2D_Factory_CreatePathGeometry($oFactory)
	Local $oSink = _D2D_PathGeometry_Open($oPath)

	Local $aBeziers[4][6] = [[3]]
	$aBeziers[1][0] = 150
	$aBeziers[1][1] = 133
	$aBeziers[1][2] = 383
	$aBeziers[1][3] = 267
	$aBeziers[1][4] = 400
	$aBeziers[1][5] = 300

	$aBeziers[2][0] = 417
	$aBeziers[2][1] = 333
	$aBeziers[2][2] = 183
	$aBeziers[2][3] = 333
	$aBeziers[2][4] = 200
	$aBeziers[2][5] = 300

	$aBeziers[3][0] = 217
	$aBeziers[3][1] = 267
	$aBeziers[3][2] = 450
	$aBeziers[3][3] = 133
	$aBeziers[3][4] = 500
	$aBeziers[3][5] = 100

	_D2D_SimplifiedGeometrySink_BeginFigure($oSink, 100, 100)
	_D2D_SimplifiedGeometrySink_AddBeziers($oSink, $aBeziers)
	_D2D_SimplifiedGeometrySink_EndFigure($oSink)
	$oSink.Close()
	$oSink = 0


	$oRender.BeginDraw()
	$oRender.DrawGeometry($oPath, $oBrush, 4, 0)
	Local $iHresult = $oRender.EndDraw(0, 0)
	ConsoleWrite("> EndDraw: " & _D2D_ErrorMessage($iHresult) & @CRLF)


	While GUIGetMsg() <> -3
	WEnd

	$oPath = 0
	$oBrush = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
