#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"
#include "..\DirectWrite.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()

	Local $hGui = GUICreate("Direct2D", 800, 400)

	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush_F = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 0, 0.4, 1)
	Local $oBrush_D = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 1, 1, 0)

	GUISetState()


	Local $oDW_Factory = _DWrite_Factory_Create()

	Local $oDW_FontFiles = _DWrite_Factory_CreateFontFileReference($oDW_Factory, @ScriptDir & "\Ethnocentric.ttf")
	Local $oDW_FontFace = _DWrite_Factory_CreateFontFace($oDW_Factory, $oDW_FontFiles)
	$oDW_FontFiles = 0

	Local $sString = "A"
	Local $iStrLen = StringLen($sString)

	Local $tGlyphIndices = _DWrite_FontFace_GetGlyphIndices($oDW_FontFace, $sString)


	Local $oPath = _D2D_Factory_CreatePathGeometry($oFactory)
	Local $oSink = _D2D_PathGeometry_Open($oPath)
	_DWrite_FontFace_GetGlyphRunOutline($oDW_FontFace, $oSink, 300, $tGlyphIndices, $iStrLen)
	$oSink.Close()
	$oSink = 0

	Local $tBounds = _D2D_Geometry_GetBounds($oPath)
	Local $tMatrix = _D2D_Matrix3x2_Translation(-($tBounds.Left + ($tBounds.Right - $tBounds.Left) * 0.5) + 400, -($tBounds.Top + ($tBounds.Bottom - $tBounds.Top) * 0.5) + 200)
	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	$oPath = 0

	Local $fLength = _D2D_Geometry_ComputeLength($oTrans)

	Local $tColor_Clear = _D2D1_COLOR_F()


	Local $iTimer = TimerInit, $fPos, $tPoint, $fX, $fY
	While GUIGetMsg() <> -3
		$fPos = Mod(TimerDiff($iTimer) / 10, $fLength)
		$oRender.BeginDraw()
		$oRender.Clear($tColor_Clear)
		$oRender.FillGeometry($oTrans, $oBrush_F, 0)
		$oRender.DrawGeometry($oTrans, $oBrush_D, 3, 0)

		$tPoint = _D2D_Geometry_ComputePointAtLength($oTrans, $fPos)
		$fX += ($tPoint.X - $fX) / 4
		$fY += ($tPoint.Y - $fY) / 4
		$oRender.DrawEllipse(_D2D1_ELLIPSE($fX, $fY, 10, 10), $oBrush_D, 4, 0)

		$oRender.EndDraw(0, 0)
	WEnd

	$oDW_FontFace = 0
	$oDW_Factory = 0

	$oTrans = 0

	$oBrush_F = 0
	$oBrush_D = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
