#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"
#include <GDIPlus.au3>

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()

	Local $hGui = GUICreate("Direct2D", 600, 400)

	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 1, 1, 0)

	GUISetState()


	Local $tMatrix_Rotate = _D2D_Matrix3x2_Rotation(45, 300, 200)
	Local $tMatrix_Skew = _D2D_Matrix3x2_Skew(20, 20, 300, 200)
	Local $tMatrix_Scale = _D2D_Matrix3x2_Scale(3, 1, 300, 200)

	Local $tMatrix = _D2D_Matrix3x2_SetProduct(_D2D_Matrix3x2_SetProduct($tMatrix_Skew, $tMatrix_Rotate), $tMatrix_Scale)


	$oRender.BeginDraw()
	_D2D_RenderTarget_DrawRectangle($oRender, 200, 100, 400, 300, $oBrush, 2)
	$oRender.SetTransform($tMatrix)
	_D2D_RenderTarget_DrawRectangle($oRender, 200, 100, 400, 300, $oBrush, 2)
	$oRender.EndDraw(0, 0)


	While GUIGetMsg() <> -3
	WEnd


	$oBrush = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
