;#AutoIt3Wrapper_Version = B
;#AutoIt3Wrapper_Run_Au3Check=N
#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"
#include "..\WIC.au3"
#include <WindowsConstants.au3>

HotKeySet("{ESC}", "_Exit")

Global $mWin = _LayeredWindow_Create("Layered", 800, 550)
GUISetState(@SW_SHOWNOACTIVATE, $mWin.Gui)


$mWin.Render.BeginDraw()
_D2D_RenderTarget_Clear($mWin.Render, 0, 0, 1)

For $y = 20 To 500 Step 60
	_D2D_RenderTarget_PushAxisAlignedClip($mWin.Render, 20, $y, 780, $y + 30) ;Set clipping rectangle
	_D2D_RenderTarget_Clear($mWin.Render, 0, 0, 0, 0) ;Make rectangle transparent
	$mWin.Render.PopAxisAlignedClip()
Next

_LayeredWindow_Update($mWin)
$mWin.Render.EndDraw(0, 0)



While Sleep(10)
WEnd



Func _LayeredWindow_Create($sTitle, $iWidth, $iHeight, $iExStyle = 0, $iX = Default, $iY = Default, $iAlpha = 0xFF)
	Local $mWin[]

	$mWin.Gui = GUICreate($sTitle, $iWidth, $iHeight, $iX, $iY, $WS_POPUP, BitOR($WS_EX_LAYERED, $iExStyle))
	$mWin.DC = _WinAPI_GetDC($mWin.Gui)

	Local $tRect = _WinAPI_GetWindowRect($mWin.Gui)

	$mWin.Blend = DllStructCreate("byte Op; byte Flags; byte Alpha; byte AlphaFormat;")
	$mWin.Blend.Alpha = $iAlpha
	$mWin.Blend.AlphaFormat = 1

	$mWin.Pos = DllStructCreate("int X; int Y;")
	$mWin.Pos.X = $tRect.Left
	$mWin.Pos.Y = $tRect.Top

	$mWin.Size = DllStructCreate("int W; int H;")
	$mWin.Size.W = $tRect.Right - $tRect.Left
	$mWin.Size.H = $tRect.Bottom - $tRect.Top

	$mWin.Src = DllStructCreate("int X; int Y;")


	Local $oWIC_Factory = _WIC_ImagingFactory_Create()
	$mWin.TargetBitmap = _WIC_ImagingFactory_CreateBitmap($oWIC_Factory, $iWidth, $iHeight)

	Local $oD2D_Factory = _D2D_Factory_Create()
	Local $test = $mWin.TargetBitmap
	$mWin.Render = _D2D_Factory_CreateWicBitmapRenderTarget($oD2D_Factory, $test, $DXGI_FORMAT_B8G8R8A8_UNORM, $D2D1_ALPHA_MODE_PREMULTIPLIED, 0, 0, $D2D1_RENDER_TARGET_USAGE_GDI_COMPATIBLE)


	Local $pD2D_Interop
	$mWin.Render.QueryInterface(_WinAPI_GUIDFromString($sIID_ID2D1GdiInteropRenderTarget), $pD2D_Interop)
	$mWin.Interop = __D2D_ObjCreate(Ptr($pD2D_Interop), $sIID_ID2D1GdiInteropRenderTarget, $tagID2D1GdiInteropRenderTarget)

	Return $mWin
EndFunc   ;==>_LayeredWindow_Create


Func _LayeredWindow_Dispose(ByRef $mWin)
	If Not IsMap($mWin) Then Return SetError(1, 0, False)
	_WinAPI_ReleaseDC($mWin.Gui, $mWin.DC)
	GUIDelete($mWin.Gui)
	$mWin = 0
EndFunc   ;==>_LayeredWindow_Dispose


Func _LayeredWindow_Update(ByRef $mWin)
	If Not IsMap($mWin) Then Return SetError(1, 0, False)

	Local $hDC
	Local $iHResult = $mWin.Interop.GetDC($D2D1_DC_INITIALIZE_MODE_COPY, $hDC)
	If $iHResult Then Return SetError($iHResult, 1, False)

	Local $aResult = DllCall("user32.dll", "bool", "UpdateLayeredWindow", "hwnd", $mWin.Gui, "handle", $mWin.DC, "struct*", $mWin.Pos, "struct*", $mWin.Size, "handle", $hDC, "struct*", $mWin.Src, "uint", 0, "struct*", $mWin.Blend, "uint", 2)

	$iHResult = $mWin.Interop.ReleaseDC(Null)
	If $iHResult Then Return SetError($iHResult, 2, False)
	If Not $aResult[0] Then Return SetError(1, 3, False)

	Return True
EndFunc   ;==>_LayeredWindow_Update


Func _Exit()
	_LayeredWindow_Dispose($mWin)
	Exit
EndFunc   ;==>_Exit
