#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"
#include <GDIPlus.au3>

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()

	Local $iGui_W = 600
	Local $iGui_H = 400
	Local $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)
	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui, $iGui_W, $iGui_H)


	;Create GDI+ Bitmap in memory and draw some stuff
	_GDIPlus_Startup()
	Local $iBmp_W = $iGui_W
	Local $iBmp_H = $iGui_H
	Local $iBmp_Stride = $iBmp_W * 4
	Local $tPixelData = DllStructCreate("uint PX[" & $iBmp_Stride * $iBmp_H & "];")


	;Local $hBitmap = _GDIPlus_BitmapCreateFromScan0($iBmp_W, $iBmp_H, $GDIP_PXF32ARGB, $iBmp_Stride, $tPixelData)
	Local $hBitmap = _GDIPlus_BitmapCreateFromScan0($iBmp_W, $iBmp_H, $GDIP_PXF32ARGB, $iBmp_Stride, DllStructGetPtr($tPixelData))


	Local $hContext = _GDIPlus_ImageGetGraphicsContext($hBitmap)
	_GDIPlus_GraphicsSetSmoothingMode($hContext, 2)
	_GDIPlus_GraphicsClear($hContext, 0xFFFFFFFF)

	Local $hPen = _GDIPlus_PenCreate(0xFFFFFF00, 3)
	_GDIPlus_GraphicsDrawRect($hContext, 10, 10, $iBmp_W - 20, $iBmp_H - 20, $hPen)

	_GDIPlus_PenSetColor($hPen, 0xFFFF00FF)
	_GDIPlus_GraphicsDrawEllipse($hContext, 100, 100, $iBmp_W - 200, $iBmp_H - 200, $hPen)
	_GDIPlus_PenDispose($hPen)

	_GDIPlus_GraphicsDrawString($hContext, "Gdi+ Bitmap in Direct2D", 40, 40)

	_GDIPlus_GraphicsDispose($hContext)
	_GDIPlus_BitmapDispose($hBitmap)
	_GDIPlus_Shutdown()


	;Create Direct2D Bitmap from memory
	Local $oBitmap = _D2D_RenderTarget_CreateBitmap($oRender, $iBmp_W, $iBmp_H, $DXGI_FORMAT_B8G8R8A8_UNORM, $D2D1_ALPHA_MODE_PREMULTIPLIED, $tPixelData, $iBmp_Stride)

	GUISetState()


	$oRender.BeginDraw()
	_D2D_RenderTarget_DrawBitmap($oRender, $oBitmap)
	$oRender.EndDraw(0, 0)

	While GUIGetMsg() <> -3
	WEnd

	$oBitmap = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
