#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\WIC.au3"
#include "..\Direct2D.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


Global $oWIC_ImagingFactory = _WIC_ImagingFactory_Create()

Global $sFile = FileOpenDialog("open imagefile", @ScriptDir & "\", "Images (*.png;*.jpg;*.bmp;*.gif;*.tif)", 1)
Global $oWIC_BitmapDecoder = _WIC_ImagingFactory_CreateDecoderFromFilename($oWIC_ImagingFactory, $sFile)
If @error Then Exit MsgBox(0, "Error", _D2D_ErrorMessage(@error))

Global $oWIC_Bitmap = _WIC_BitmapDecoder_GetFrame($oWIC_BitmapDecoder)
Global $oWIC_FormatConverter = _WIC_ImagingFactory_CreateFormatConverter($oWIC_ImagingFactory)
$oWIC_FormatConverter.Initialize($oWIC_Bitmap, _WinAPI_GUIDFromString($sGUID_WICPixelFormat32bppPBGRA), 0, 0, 0, 1)

Global $iImgW, $iImgH
$oWIC_FormatConverter.GetSize($iImgW, $iImgH)



Global $fScale = @DesktopWidth / $iImgW
Global $fScaleY = @DesktopHeight / $iImgH
If $fScaleY < $fScale Then $fScale = $fScaleY

Global $iGui_W = $iImgW * $fScale * 0.8
Global $iGui_H = $iImgH * $fScale * 0.8
Global $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)

Global $oD2D_Factory = _D2D_Factory_Create()
Global $oD2D_HwndRenderTarget = _D2D_Factory_CreateHwndRenderTarget($oD2D_Factory, $hGui)
Global $oD2D_Bitmap = _D2D_RenderTarget_CreateBitmapFromWicBitmap($oD2D_HwndRenderTarget, $oWIC_FormatConverter)
$oWIC_Bitmap = 0
$oWIC_BitmapDecoder = 0
$oWIC_FormatConverter = 0
$oWIC_ImagingFactory = 0

GUISetState()


$oD2D_HwndRenderTarget.BeginDraw()
$oD2D_HwndRenderTarget.DrawBitmap($oD2D_Bitmap, _D2D1_RECT_F(0, 0, $iGui_W, $iGui_H), 1, 1, Null)
$oD2D_HwndRenderTarget.EndDraw(0, 0)


While GUIGetMsg() <> -3
WEnd

$oD2D_Bitmap = 0
$oD2D_HwndRenderTarget = 0
$oD2D_Factory = 0

GUIDelete($hGui)
