#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"
#include "..\DirectWrite.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()

	Local $hGui = GUICreate("Direct2D", 800, 300)

	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 0, 0.4, 1)

	GUISetState()


	Local $oDW_Factory = _DWrite_Factory_Create()

	;Create "Arial" FontFace from SystemFontCollection
	Local $oDW_FontCollection = _DWrite_Factory_GetSystemFontCollection($oDW_Factory)
	Local $iFontIndex, $bExists
	$oDW_FontCollection.FindFamilyName("Arial", $iFontIndex, $bExists)
	If Not $bExists Then Exit MsgBox(0, "Error", "FontFamily <Arial> not found in SystemFontCollection!")
	Local $oDW_FontFamily = _DWrite_FontCollection_GetFontFamily($oDW_FontCollection, $iFontIndex)
	Local $oDW_Font = _DWrite_FontFamily_GetFirstMatchingFont($oDW_FontFamily)
	Local $oDW_FontFace = _DWrite_Font_CreateFontFace($oDW_Font)
	$oDW_Font = 0
	$oDW_FontFamily = 0
	$oDW_FontCollection = 0



	Local $sString = "AutoIt rulez!"
	Local $iStrLen = StringLen($sString)
	Local $tGlyphIndices = _DWrite_FontFace_GetGlyphIndices($oDW_FontFace, $sString)
	Local $tGlyphOffsets = DllStructCreate("float XY[" & $iStrLen * 2 & "];")


	Local $iTimer = TimerInit(), $fStep
	While GUIGetMsg() <> -3
		$fStep = TimerDiff($iTimer) / 100
		For $i = 0 To $iStrLen - 1
			$tGlyphOffsets.XY(($i * 2 + 1)) = Cos($fStep + $i) * 10 ;X-Offset
			$tGlyphOffsets.XY(($i * 2 + 2)) = Sin($fStep + $i) * 40 ;Y-Offset
		Next

		$oRender.BeginDraw()
		_D2D_RenderTarget_Clear($oRender)
		_D2D_RenderTarget_DrawGlyphRun($oRender, $tGlyphIndices, $iStrLen, $oDW_FontFace, 128, $oBrush, 50, 180, Null, $tGlyphOffsets)
		$oRender.EndDraw(0, 0)
	WEnd

	$oDW_Factory = 0
	$oDW_FontFace = 0

	$oBrush = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
