#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y
#include "..\Direct2D.au3"
#include "..\DirectWrite.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()

	Local $sString = "Hello World"

	Local $hGui = GUICreate("Direct2D", 800, 300)
	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 1, 1, 0)

	Local $oDW_Factory = _DWrite_Factory_Create()
	Local $oDW_Format = _DWrite_Factory_CreateTextFormat($oDW_Factory, "Arial", 128)

	GUISetState()


	$oRender.BeginDraw()
	_D2D_RenderTarget_Clear($oRender, 0, 0, 0.3)
	_D2D_RenderTarget_DrawText($oRender, $sString, $oDW_Format, 0, 0, 800, 300, $oBrush)
	$oRender.EndDraw(0, 0)


	While GUIGetMsg() <> -3
	WEnd

	$oDW_Format = 0
	$oDW_Factory = 0

	$oBrush = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
