#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = n
#include "..\Direct2D.au3"
#include "..\DirectWrite.au3"

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()

	Local $sString = "Once upon a time, there was a beautiful princess who lived in a beautiful castle. One day she..." & @CRLF & @CRLF & @TAB & "...and they lived happily until the end of their days."

	Local $hGui = GUICreate("Direct2D", 805, 450)

	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 0.2, 0.3, 1, 0.8)

	GUISetState()

	Local $oDW_Factory = _DWrite_Factory_Create()
	Local $oDW_Format = _DWrite_Factory_CreateTextFormat($oDW_Factory, "Gabriola", 36, $DWRITE_FONT_WEIGHT_EXTRA_BOLD, $DWRITE_FONT_STYLE_ITALIC)
	$oDW_Format.SetTextAlignment(2)
	$oDW_Format.SetParagraphAlignment(2)

	Local $oDW_Typography = _DWrite_Factory_CreateTypography($oDW_Factory)
	_DWrite_Typography_AddFontFeature($oDW_Typography, $DWRITE_FONT_FEATURE_TAG_STYLISTIC_SET_6, 1)

	Local $oDW_Layout = _DWrite_Factory_CreateTextLayout($oDW_Factory, $sString, $oDW_Format, 725, 450)
	_DWrite_TextLayout_SetTypography($oDW_Layout, $oDW_Typography)




	$oRender.BeginDraw()
	_D2D_RenderTarget_Clear($oRender, 1, 0.9, 0.9)
	_D2D_RenderTarget_DrawTextLayout($oRender, 40, -20, $oDW_Layout, $oBrush)
	$oRender.EndDraw(0, 0)


	While GUIGetMsg() <> -3
	WEnd

	$oDW_Layout = 0
	$oDW_Typography = 0
	$oDW_Format = 0
	$oDW_Factory = 0

	$oBrush = 0
	$oRender = 0
	$oFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example
