#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y

#include "..\Direct2D.au3"
#include "..\WIC.au3"
#include <WinAPIShellEx.au3>

Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_Example()


Func _Example()
	Local $iGui_W = @DesktopWidth * 0.9
	Local $iGui_H = @DesktopHeight * 0.9
	Local $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)
	GUISetState()


	Local $oD2D_Factory = _D2D_Factory_Create()
	Local $oD2D_RenderTarget = _D2D_Factory_CreateHwndRenderTarget($oD2D_Factory, $hGui)

	Local $oWIC_ImagingFactory = _WIC_ImagingFactory_Create()

	Local $iIconSize = 64
	Local $iIconIndex = 0, $iX, $iY
	Local $iCX = Floor($iGui_W / ($iIconSize + 10))
	Local $iCY = Floor($iGui_H / ($iIconSize + 10))
	$oD2D_RenderTarget.BeginDraw()

	While 1
		$iX = Mod($iIconIndex, $iCX) * ($iIconSize + 10) + 20
		$iY = Floor($iIconIndex / $iCX) * ($iIconSize + 10) + 20
		If Floor($iIconIndex / $iCX) >= $iCY Then ExitLoop

		_DrawIcon($oD2D_RenderTarget, $oWIC_ImagingFactory, $iX, $iY, $iIconIndex, $iIconSize)

		$iIconIndex += 1
	WEnd
	$oD2D_RenderTarget.EndDraw(0, 0)


	While GUIGetMsg() <> -3
	WEnd

	$oD2D_RenderTarget = 0
	$oD2D_Factory = 0
	$oWIC_ImagingFactory = 0

	GUIDelete($hGui)
EndFunc   ;==>_Example


Func _DrawIcon($oD2D_RenderTarget, $oWIC_ImagingFactory, $iX, $iY, $iIconIndex, $iIconSize)
	Local $hIcon = _WinAPI_ShellExtractIcon(@SystemDir & "\imageres.dll", $iIconIndex, $iIconSize, $iIconSize)
	Local $oWIC_Bitmap = _WIC_ImagingFactory_CreateBitmapFromHICON($oWIC_ImagingFactory, $hIcon)
	_WinAPI_DestroyIcon($hIcon)

	Local $oWIC_FormatConverter = _WIC_ImagingFactory_CreateFormatConverter($oWIC_ImagingFactory)
	$oWIC_FormatConverter.Initialize($oWIC_Bitmap, _WinAPI_GUIDFromString($sGUID_WICPixelFormat32bppPBGRA), 0, 0, 0, 1)
	Local $oD2D_Bitmap = _D2D_RenderTarget_CreateBitmapFromWicBitmap($oD2D_RenderTarget, $oWIC_FormatConverter)

	$oD2D_RenderTarget.DrawBitmap($oD2D_Bitmap, _D2D1_RECT_F($iX, $iY, $iX + $iIconSize, $iY + $iIconSize), 1, 1, Null)
EndFunc   ;==>_DrawIcon
