#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y

#include "..\Direct2D.au3"
#include "..\DirectWrite.au3"


Global $iGui_W = 600
Global $iGui_H = 600

Global $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)

Global $oFactory = _D2D_Factory_Create()
Global $oRender = _D2D_Factory_CreateHwndRenderTarget($oFactory, $hGui, $iGui_W, $iGui_H)
Global $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 0, 0.7, 1)

Global $aLogo = _AutoItLogo_CreateLogo($oFactory, $iGui_H * 0.8, $iGui_W * 0.5, $iGui_H * 0.5)

GUISetState()


$oRender.BeginDraw()
$oRender.FillGeometry($aLogo[0], $oBrush, Null)
$oRender.EndDraw(0, 0)


While GUIGetMsg() <> -3
WEnd
GUIDelete($hGui)




Func __AutoItLogo_Create_3(ByRef Const $oFactory, $fLogoSize = 256, $fCX = 0, $fCY = 0)
	Local $oDW_Factory = _DWrite_Factory_Create()
	Local $oFontFiles = _DWrite_Factory_CreateFontFileReference($oDW_Factory, @ScriptDir & "\Ethnocentric.ttf")
	Local $oFontFace = _DWrite_Factory_CreateFontFace($oDW_Factory, $oFontFiles)
	Local $oPath = __AutoItLogo_CreateText($oFactory, "3", $oFontFace, 96, 73, -105, 36, 28)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>__AutoItLogo_Create_3



Func __AutoItLogo_Create_A(ByRef Const $oFactory, $fLogoSize = 256, $fCX = 0, $fCY = 0)
	Local $oDW_Factory = _DWrite_Factory_Create()
	Local $oFontFiles = _DWrite_Factory_CreateFontFileReference($oDW_Factory, @ScriptDir & "\Ethnocentric.ttf")
	Local $oFontFace = _DWrite_Factory_CreateFontFace($oDW_Factory, $oFontFiles)
	Local $oPath = __AutoItLogo_CreateText($oFactory, "A", $oFontFace, 96, -76, -58, 152, 92)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>__AutoItLogo_Create_A


Func __AutoItLogo_Create_Inner(ByRef Const $oFactory, $fLogoSize = 256, $fCX = 0, $fCY = 0)
	Local $oPath = _D2D_Factory_CreateEllipseGeometry($oFactory, 0, 0, 90, 90)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>__AutoItLogo_Create_Inner



Func __AutoItLogo_Create_Outer(ByRef Const $oFactory, $fLogoSize = 256, $fCX = 0, $fCY = 0)
	Local $oPath = _D2D_Factory_CreateEllipseGeometry($oFactory, 0, 0, 115, 115)
	Local $oPath2 = _D2D_Factory_CreateEllipseGeometry($oFactory, 90, -90, 34, 34)
	$oPath = _D2D_Geometry_CombineWithGeometry($oPath, $oPath2, $D2D1_COMBINE_MODE_UNION)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>__AutoItLogo_Create_Outer





Func _AutoItLogo_CreateLogo(ByRef Const $oFactory, $fLogoSize = 256, $fCX = 0, $fCY = 0)
	Local $oPath_O = __AutoItLogo_Create_Outer($oFactory, $fLogoSize, $fCX, $fCY)
	Local $oPath_I = __AutoItLogo_Create_Inner($oFactory, $fLogoSize, $fCX, $fCY)
	Local $oPath_A = __AutoItLogo_Create_A($oFactory, $fLogoSize, $fCX, $fCY)
	Local $oPath_3 = __AutoItLogo_Create_3($oFactory, $fLogoSize, $fCX, $fCY)

	Local $oPath_Ring = _D2D_Geometry_CombineWithGeometry($oPath_O, $oPath_I, $D2D1_COMBINE_MODE_EXCLUDE)
	$oPath_Ring = _D2D_Geometry_CombineWithGeometry($oPath_Ring, $oPath_3, $D2D1_COMBINE_MODE_EXCLUDE)

	Local $aLogo[6]
	$aLogo[0] = _D2D_Geometry_CombineWithGeometry($oPath_Ring, $oPath_A, $D2D1_COMBINE_MODE_UNION)
	$aLogo[1] = $oPath_Ring
	$aLogo[2] = $oPath_A
	$aLogo[3] = $oPath_O
	$aLogo[4] = $oPath_I
	$aLogo[5] = $oPath_3

	Return $aLogo
EndFunc   ;==>_AutoItLogo_CreateLogo






Func __AutoItLogo_CreateText(ByRef Const $oFactory, $sString, ByRef Const $oFontFace, $fSize, $fX = 0, $fY = 0, $fW = 0, $fH = 0)
	Local $iStrLen = StringLen($sString)

	Local $tGlyphIndices = _DWrite_FontFace_GetGlyphIndices($oFontFace, $sString)

	Local $oPath = _D2D_Factory_CreatePathGeometry($oFactory)
	Local $oSink = _D2D_PathGeometry_Open($oPath)
	_DWrite_FontFace_GetGlyphRunOutline($oFontFace, $oSink, $fSize, $tGlyphIndices, $iStrLen)
	$oSink.Close()
	$oSink = 0

	Local $tBounds = _D2D_Geometry_GetBounds($oPath)

	Local $fScaleX = 1, $fScaleY = 1
	If $fW <> 0 Then $fScaleX = $fW / ($tBounds.Right - $tBounds.Left)
	If $fH <> 0 Then $fScaleY = $fH / ($tBounds.Bottom - $tBounds.Top)

	Local $tMatrix = DllStructCreate($tagD2D1_MATRIX_3X2_F)
	$tMatrix.M11 = $fScaleX
	$tMatrix.M22 = $fScaleY
	$tMatrix.M31 = $fX - $tBounds.Left * $fScaleX
	$tMatrix.M32 = $fY - $tBounds.Top * $fScaleY

	Local $oPathTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	$oPath = 0

	Return $oPathTrans
EndFunc   ;==>__AutoItLogo_CreateText


