#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y

#include "..\Direct2D_1.au3"
#include "..\DirectWrite.au3"


Global $iGui_W = 600
Global $iGui_H = 600

Global $hGui = GUICreate("Direct2D", $iGui_W, $iGui_H)

Global $oFactory = _D2D_Factory1_Create()
Global $oContext, $oSwapChain
_D2D_CreateHWNDContext($oFactory, $hGui, $oContext, $oSwapChain)
If @error Then Exit MsgBox(0, "Error", _D2D_ErrorMessage(@error) & @CRLF & "You need Win8 or Win7+PlatformUpdate to run this example")

Global $aLogo = _AutoItLogo_CreateLogo($oFactory, $iGui_H * 0.8, $iGui_W * 0.5, $iGui_H * 0.5)
Global $oAluBrush = __AutoItLogo_CreateAluBrush($oContext, $iGui_W, $iGui_H)

GUISetState()

$oContext.BeginDraw()
__AutoItLogo_DrawInner($oContext, $aLogo[4], $iGui_H * 0.8, $iGui_W * 0.5, $iGui_H * 0.5)
__AutoItLogo_DrawAlu($oContext, $oAluBrush, $aLogo[0], $iGui_W, $iGui_H)
$oContext.EndDraw(0, 0)
$oSwapChain.Present(1, 0)


While GUIGetMsg() <> -3
WEnd

GUIDelete($hGui)





Func __AutoItLogo_DrawAlu(ByRef Const $oContext, ByRef Const $oBrush, ByRef Const $oPath, $iW, $iH)
	Local $oBuffer = _D2D_RenderTarget_CreateCompatibleRenderTarget($oContext)
	Local $oBitmap = _D2D_BitmapRenderTarget_GetBitmap($oBuffer)

	$oBuffer.BeginDraw()
	$oBuffer.FillGeometry($oPath, $oBrush, Null)
	$oBuffer.EndDraw(0, 0)


	Local $oFX_GaussianBlur = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1GaussianBlur)
	$oFX_GaussianBlur.SetValue($D2D1_GAUSSIANBLUR_PROP_STANDARD_DEVIATION, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(3), _D2D1_SIZEOF("float"))

	Local $oFX_PointSpecular = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1PointSpecular)
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_LIGHT_POSITION, $D2D1_PROPERTY_TYPE_VECTOR3, _D2D1_VECTOR_3F($iW * 0.2, $iH * 1.3, $iH * 0.1), _D2D1_SIZEOF($tagD2D1_VECTOR_3F))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SPECULAR_EXPONENT, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(1), _D2D1_SIZEOF("float"))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SURFACE_SCALE, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(3), _D2D1_SIZEOF("float"))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SPECULAR_CONSTANT, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(1.2), _D2D1_SIZEOF("float"))

	Local $oFX_Composite = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1Composite)
	$oFX_Composite.SetValue($D2D1_COMPOSITE_PROP_MODE, $D2D1_PROPERTY_TYPE_ENUM, _D2D1_UINT($D2D1_COMPOSITE_MODE_SOURCE_IN), _D2D1_SIZEOF("uint"))

	Local $oFX_Arithmetic = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1ArithmeticComposite)
	$oFX_Arithmetic.SetValue($D2D1_ARITHMETICCOMPOSITE_PROP_COEFFICIENTS, $D2D1_PROPERTY_TYPE_VECTOR4, _D2D1_VECTOR_4F(1, 0, 0, 0), _D2D1_SIZEOF($tagD2D1_VECTOR_4F))

	$oFX_GaussianBlur.SetInput(0, $oBitmap, True)
	_D2D_Effect_SetInputEffect($oFX_PointSpecular, $oFX_GaussianBlur)

	$oFX_Composite.SetInput(0, $oBitmap, True)
	_D2D_Effect_SetInputEffect($oFX_Composite, $oFX_PointSpecular, 1)

	$oFX_Arithmetic.SetInput(0, $oBitmap, True)
	_D2D_Effect_SetInputEffect($oFX_Arithmetic, $oFX_Composite, 1)

	Local $pOutPut
	$oFX_Arithmetic.GetOutput($pOutPut)

	$oContext.DrawImage($pOutPut, Null, Null, 0, 0)
EndFunc





Func __AutoItLogo_DrawInner(ByRef Const $oContext, ByRef Const $oPath, $fLogoSize = 256, $fCX =0,$fCY = 0)
	Local $aStop[3] = [2]
	$aStop[1] = _D2D1_GRADIENT_STOP(0, 1, 1, 1)
	$aStop[2] = _D2D1_GRADIENT_STOP(1, 1, 1, 1, 0)

	Local $oStopCollection = _D2D_RenderTarget_CreateGradientStopCollection($oContext, $aStop)
	Local $oBrush = _D2D_RenderTarget_CreateRadialGradientBrush($oContext, $oStopCollection)

	$aStop[1].R = 0.38
	$aStop[1].G = 0.49
	$aStop[1].B = 0.82
	$aStop[2].R = 0.09
	$aStop[2].G = 0.12
	$aStop[2].B = 0.22
	$aStop[2].A = 1
	$oStopCollection = _D2D_RenderTarget_CreateGradientStopCollection($oContext, $aStop)
	Local $oBrush1 = _D2D_RenderTarget_CreateRadialGradientBrush($oContext, $oStopCollection)


	Local $fScale = $fLogoSize / 230

	$oBrush.SetCenter(_D2D1_POINT_2F($fCX, $fCY))
	$oBrush.SetRadiusX(90 * $fScale)
	$oBrush.SetRadiusY(90 * $fScale)

	$oBrush1.SetCenter(_D2D1_POINT_2F($fCX, $fCY))
	$oBrush1.SetRadiusX(90 * $fScale)
	$oBrush1.SetRadiusY(90 * $fScale)


	Local $oBuffer = _D2D_RenderTarget_CreateCompatibleRenderTarget($oContext)
	Local $oBitmap = _D2D_BitmapRenderTarget_GetBitmap($oBuffer)

	$oBuffer.BeginDraw()
	$oBuffer.FillGeometry($oPath, $oBrush, Null)
	$oBuffer.EndDraw(0, 0)

	Local $oBuffer1 = _D2D_RenderTarget_CreateCompatibleRenderTarget($oContext)
	Local $oBitmap1 = _D2D_BitmapRenderTarget_GetBitmap($oBuffer1)

	$oBuffer1.BeginDraw()
	$oBuffer1.FillGeometry($oPath, $oBrush1, Null)
	$oBuffer1.EndDraw(0, 0)


	Local $oFX_PointSpecular = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1PointSpecular)
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_LIGHT_POSITION, $D2D1_PROPERTY_TYPE_VECTOR3, _D2D1_VECTOR_3F($iGui_W * 0.48, $iGui_H * 0.48, $iGui_H * 0.3), _D2D1_SIZEOF($tagD2D1_VECTOR_3F))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SPECULAR_EXPONENT, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(4), _D2D1_SIZEOF("float"))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SURFACE_SCALE, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(3), _D2D1_SIZEOF("float"))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SPECULAR_CONSTANT, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(1), _D2D1_SIZEOF("float"))


	Local $oFX_Composite = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1Composite)
	$oFX_Composite.SetValue($D2D1_COMPOSITE_PROP_MODE, $D2D1_PROPERTY_TYPE_ENUM, _D2D1_UINT($D2D1_COMPOSITE_MODE_SOURCE_IN), _D2D1_SIZEOF("uint"))

	Local $oFX_Arithmetic = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1ArithmeticComposite)
	$oFX_Arithmetic.SetValue($D2D1_ARITHMETICCOMPOSITE_PROP_COEFFICIENTS, $D2D1_PROPERTY_TYPE_VECTOR4, _D2D1_VECTOR_4F(1, 0, 0, 0), _D2D1_SIZEOF($tagD2D1_VECTOR_4F))


	$oFX_PointSpecular.SetInput(0, $oBitmap, True)

	$oFX_Composite.SetInput(0, $oBitmap1, True)
	_D2D_Effect_SetInputEffect($oFX_Composite, $oFX_PointSpecular, 1)

	$oFX_Arithmetic.SetInput(0, $oBitmap1, True)
	_D2D_Effect_SetInputEffect($oFX_Arithmetic, $oFX_Composite, 1)

	Local $pOutPut
	$oFX_Arithmetic.GetOutput($pOutPut)

	$oContext.DrawImage($pOutPut, Null, Null, 0, 0)
EndFunc



Func __AutoItLogo_CreateAluBrush(ByRef Const $oContext, $iW, $iH)
	Local $oFX_Turbulence = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1Turbulence)

	Local $tVector2F = _D2D1_VECTOR_2F($iW, $iH)
	$oFX_Turbulence.SetValue($D2D1_TURBULENCE_PROP_SIZE, $D2D1_PROPERTY_TYPE_VECTOR2, $tVector2F, DllStructGetSize($tVector2F))
	$oFX_Turbulence.SetValue($D2D1_TURBULENCE_PROP_NUM_OCTAVES, $D2D1_PROPERTY_TYPE_UINT32, _D2D1_UINT(8), _D2D1_SIZEOF("uint"))

	Local $oFX_PointSpecular = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1PointSpecular)
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_LIGHT_POSITION, $D2D1_PROPERTY_TYPE_VECTOR3, _D2D1_VECTOR_3F($iW * 0.5, $iH * 2, $iH * 0.3), _D2D1_SIZEOF($tagD2D1_VECTOR_3F))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SPECULAR_EXPONENT, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(1.2), _D2D1_SIZEOF("float"))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SURFACE_SCALE, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(3), _D2D1_SIZEOF("float"))
	$oFX_PointSpecular.SetValue($D2D1_POINTSPECULAR_PROP_SPECULAR_CONSTANT, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(1.2), _D2D1_SIZEOF("float"))

	Local $oFX_MotionBlur = _D2D_DeviceContext_CreateEffect($oContext, $sIID_D2D1DirectionalBlur)
	$oFX_MotionBlur.SetValue($D2D1_DIRECTIONALBLUR_PROP_STANDARD_DEVIATION, $D2D1_PROPERTY_TYPE_FLOAT, _D2D1_FLOAT(64), _D2D1_SIZEOF("float"))
	$oFX_MotionBlur.SetValue($D2D1_DIRECTIONALBLUR_PROP_BORDER_MODE, $D2D1_PROPERTY_TYPE_ENUM, _D2D1_UINT($D2D1_BORDER_MODE_HARD), _D2D1_SIZEOF("uint"))

	_D2D_Effect_SetInputEffect($oFX_PointSpecular, $oFX_Turbulence)
	_D2D_Effect_SetInputEffect($oFX_MotionBlur, $oFX_PointSpecular)

	Local $pOutPut
	$oFX_MotionBlur.GetOutput($pOutPut)
	Local $oImgBrush = _D2D_DeviceContext_CreateImageBrush($oContext, $pOutPut, 0, 0, $tVector2F.X, $tVector2F.Y)

	Return $oImgBrush
EndFunc



Func __AutoItLogo_Create_3(ByRef Const $oFactory, $fLogoSize = 256, $fCX =0,$fCY = 0)
	Local $oDW_Factory = _DWrite_Factory_Create()
	Local $oFontFiles = _DWrite_Factory_CreateFontFileReference($oDW_Factory, @ScriptDir & "\Ethnocentric.ttf")
	Local $oFontFace = _DWrite_Factory_CreateFontFace($oDW_Factory, $oFontFiles)
	Local $oPath = __AutoItLogo_CreateText($oFactory, "3", $oFontFace, 96, 73,-105, 36, 28)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>_CreateBitmap



Func __AutoItLogo_Create_A(ByRef Const $oFactory, $fLogoSize = 256, $fCX =0,$fCY = 0)
	Local $oDW_Factory = _DWrite_Factory_Create()
	Local $oFontFiles = _DWrite_Factory_CreateFontFileReference($oDW_Factory, @ScriptDir & "\Ethnocentric.ttf")
	Local $oFontFace = _DWrite_Factory_CreateFontFace($oDW_Factory, $oFontFiles)
	Local $oPath = __AutoItLogo_CreateText($oFactory, "A", $oFontFace, 96, -76,-58, 152, 92)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>_CreateBitmap


Func __AutoItLogo_Create_Inner(ByRef Const $oFactory, $fLogoSize = 256, $fCX =0,$fCY = 0)
	Local $oPath = _D2D_Factory_CreateEllipseGeometry($oFactory, 0,0,90,90)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>_CreateBitmap



Func __AutoItLogo_Create_Outer(ByRef Const $oFactory, $fLogoSize = 256, $fCX =0,$fCY = 0)
	Local $oPath = _D2D_Factory_CreateEllipseGeometry($oFactory, 0,0, 115,115)
	Local $oPath2 = _D2D_Factory_CreateEllipseGeometry($oFactory, 90,-90,34,34)
	$oPath = _D2D_Geometry_CombineWithGeometry($oPath, $oPath2, $D2D1_COMBINE_MODE_UNION)

	Local $fScale = $fLogoSize / 230
	Local $tMatrix = _D2D_MATRIX3X2_SetProduct(_D2D_MATRIX3X2_Scale($fScale, $fScale), _D2D_MATRIX3X2_Translation($fCX, $fCY))

	Local $oTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	Return $oTrans
EndFunc   ;==>_CreateBitmap





Func _AutoItLogo_CreateLogo(ByRef Const $oFactory, $fLogoSize = 256, $fCX = 0, $fCY = 0)
	Local $oPath_O = __AutoItLogo_Create_Outer($oFactory, $fLogoSize, $fCX, $fCY)
	Local $oPath_I = __AutoItLogo_Create_Inner($oFactory, $fLogoSize, $fCX, $fCY)
	Local $oPath_A = __AutoItLogo_Create_A($oFactory, $fLogoSize, $fCX, $fCY)
	Local $oPath_3 = __AutoItLogo_Create_3($oFactory, $fLogoSize, $fCX, $fCY)

	Local $oPath_Ring = _D2D_Geometry_CombineWithGeometry($oPath_O, $oPath_I, $D2D1_COMBINE_MODE_EXCLUDE)
	$oPath_Ring = _D2D_Geometry_CombineWithGeometry($oPath_Ring, $oPath_3, $D2D1_COMBINE_MODE_EXCLUDE)

	Local $aLogo[6]
	$aLogo[0] = _D2D_Geometry_CombineWithGeometry($oPath_Ring, $oPath_A, $D2D1_COMBINE_MODE_UNION)
	$aLogo[1] = $oPath_Ring
	$aLogo[2] = $oPath_A
	$aLogo[3] = $oPath_O
	$aLogo[4] = $oPath_I
	$aLogo[5] = $oPath_3

	Return $aLogo
EndFunc   ;==>_CreateBitmap






Func __AutoItLogo_CreateText(ByRef Const $oFactory, $sString, ByRef Const $oFontFace, $fSize, $fX = 0, $fY = 0, $fW = 0, $fH = 0)
	Local $iStrLen = StringLen($sString)

	Local $tGlyphIndices = _DWrite_FontFace_GetGlyphIndices($oFontFace, $sString)

	Local $oPath = _D2D_Factory_CreatePathGeometry($oFactory)
	Local $oSink = _D2D_PathGeometry_Open($oPath)
	_DWrite_FontFace_GetGlyphRunOutline($oFontFace, $oSink, $fSize, $tGlyphIndices, $iStrLen)
	$oSink.Close()
	$oSink = 0

	Local $tBounds = _D2D_Geometry_GetBounds($oPath)

	Local $fScaleX = 1, $fScaleY = 1
	If $fW <> 0 Then $fScaleX = $fW / ($tBounds.Right - $tBounds.Left)
	If $fH <> 0 Then $fScaleY = $fH / ($tBounds.Bottom - $tBounds.Top)

	Local $tMatrix = DllStructCreate($tagD2D1_MATRIX_3X2_F)
	$tMatrix.M11 = $fScaleX
	$tMatrix.M22 = $fScaleY
	$tMatrix.M31 = $fX - $tBounds.Left * $fScaleX
	$tMatrix.M32 = $fY - $tBounds.Top * $fScaleY

	Local $oPathTrans = _D2D_Factory_CreateTransformedGeometry($oFactory, $oPath, $tMatrix)
	$oPath = 0

	Return $oPathTrans
EndFunc   ;==>__AutoItLogo_CreateText


