#AutoIt3Wrapper_AU3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
;#AutoIt3Wrapper_UseX64 = y

#include "..\WIC.au3"
#include "..\Direct2D.au3"
#include "..\DirectWrite.au3"


Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("COM Error, ScriptLine(" & $oError.ScriptLine & ") : Number 0x" & Hex($oError.Number, 8) & " - " & $oError.WinDescription & @CRLF)
EndFunc   ;==>_ErrFunc


_CreateAnimatedGif(@MyDocumentsDir & "\Anim.gif")
ShellExecute(@MyDocumentsDir & "\Anim.gif")








Func _CreateAnimatedGif($sFile, $iFrames = 4, $iW = 400, $iH = 300)
	Local $oWIC_Factory = _WIC_ImagingFactory_Create()
	Local $oWIC_Bitmap = _WIC_ImagingFactory_CreateBitmap($oWIC_Factory, $iW, $iH)

	Local $oFactory = _D2D_Factory_Create()
	Local $oRender = _D2D_Factory_CreateWicBitmapRenderTarget($oFactory, $oWIC_Bitmap)

	Local $oStream = _WIC_ImagingFactory_CreateStream($oWIC_Factory)
	$oStream.InitializeFromFilename($sFile, $GENERIC_WRITE)

	Local $oEncoder = _WIC_ImagingFactory_CreateEncoder($oWIC_Factory, $sGUID_ContainerFormatGif)
	$oEncoder.Initialize($oStream, $WICBitmapEncoderNoCache)


	Local $tFormat = _WinAPI_GUIDFromString($sGUID_WICPixelFormat32bppPBGRA)
	Local $oFrame, $oProp, $oQueryWriter, $tVariant

	Local $iSleep

	For $i = 1 To $iFrames
		$iSleep = Int($i / $iFrames * 1000)

		$oFrame = _WIC_BitmapEncoder_CreateNewFrame($oEncoder, $oProp)
		$oFrame.Initialize($oProp)

		$oQueryWriter = _WIC_BitmapFrameEncode_GetMetadataQueryWriter($oFrame)
		$tVariant = DllStructCreate("ushort Type; ushort[3]; ushort Val;")
		$tVariant.Type = 18
		$tVariant.Val = $iSleep / 10
		$oQueryWriter.SetMetadataByName("/grctlext/Delay", $tVariant)

		$oFrame.SetSize($iW, $iH)
		$oFrame.SetPixelFormat($tFormat)


		_DrawFrame($oRender, $i, $iFrames, $iSleep)

		$oFrame.WriteSource($oWIC_Bitmap, Null)

		$oFrame.Commit()

		$oQueryWriter = 0
		$oFrame = 0
		$oProp = 0
	Next

	$oEncoder.Commit()

	$oEncoder = 0
	$oStream = 0
	$oRender = 0
	$oFactory = 0
	$oWIC_Bitmap = 0
	$oWIC_Factory = 0

	Return True
EndFunc   ;==>_CreateAnimatedGif



Func _DrawFrame(ByRef Const $oRender, $iIndex, $iFrames, $iSleep)
	Local $oDW_Factory = _DWrite_Factory_Create()
	Local $oDW_Format = _DWrite_Factory_CreateTextFormat($oDW_Factory, "Arial", 24)
	Local $oBrush = _D2D_RenderTarget_CreateSolidColorBrush($oRender, 0, 0, 0)

	Local $sString = "Frame: " & $iIndex & "/" & $iFrames & @CRLF & "Delay: " & $iSleep & "ms"

	$oRender.BeginDraw()
	$oRender.Clear(_D2D1_COLOR_F($iIndex / $iFrames, 0, $iIndex / $iFrames))
	$oRender.DrawText($sString, StringLen($sString), $oDW_Format, _D2D1_RECT_F(10, 10, 200, 100), $oBrush, 0, 0)
	$oRender.EndDraw(0, 0)
EndFunc   ;==>_DrawFrame
