#include-once
#include 'EasyD2D\EasyD2D.au3'

; #BEISPIEL# ====================================================================================================================
; Author ........: Mars
; Modified ......:
; ===============================================================================================================================

Opt('GUIOnEventMode', 1)
_ED2D_Startup()
Global $bExit = False
Global $hGUI = GUICreate('Test', 512, 512)
Global $hTAR = _ED2D_RenderTargetCreateFromHWND($hGUI)
	_ED2D_SetMainRenderTarget($hTAR)
Global $hBUF = _ED2D_RenderTargetCreateFromRenderTarget($hTAR)
Global $hBMP = _ED2D_RenderTargetGetBitmap($hBUF)
Global $hIMG = _ED2D_BitmapCreateFromFile('Mona.jpg')
Global $hIMG2 = _ED2D_BitmapCreateFromFile('Mona.jpg')
Global $t = TimerInit(), $iTimer, $iTime, $iFrameTimer = TimerInit()

GUISetOnEvent(-3, 'EVENT', $hGUI)
GUISetState(@SW_SHOW, $hGUI)

While Not $bExit
	$iTimer = TimerInit()
	_ED2D_BitmapMove($hIMG, $hIMG2, 5 * Sin(TimerDiff($t) / 1000) + 3 * Cos(TimerDiff($t) / 3000), 5 * Cos(TimerDiff($t) / 1000) + 3 * Sin(TimerDiff($t) / 7000))
	$iTime = (TimerDiff($iTimer) + $iTime * 19) / 20
	If TimerDiff($iFrameTimer) > 1000 Then
		WinSetTitle($hGUI, '', 'BitmapMove: ' & Round($iTime, 1) & ' ms')
		$iFrameTimer = TimerInit()
	EndIf
	_ED2D_RenderTargetBeginDraw($hBUF)
	_ED2D_RenderTargetDrawBitmap($hBUF, 0, 0, 512, 512, $hIMG)
	_ED2D_RenderTargetEndDraw($hBUF)
	_ED2D_RenderTargetDrawBitmapOnHWND($hBMP)
WEnd

_ED2D_BitmapDispose($hIMG)
_ED2D_BitmapDispose($hIMG2)
_ED2D_BitmapDispose($hBMP)
_ED2D_RenderTargetDispose($hBUF)
_ED2D_RenderTargetDispose($hTAR)
_ED2D_Shutdown()

Func EVENT()
	Switch @GUI_CtrlId
		Case -3
			$bExit = True
	EndSwitch
EndFunc

Func Max($a, $b)
	If $a < $b Then Return $b
	Return $a
EndFunc

Func _ED2D_BitmapMove($oBMP, $oClone, $dx, $dy)
	$dx = Round($dx, 0)
	$dy = Round($dy, 0)
	Local $vSize = DllStructCreate($tagD2D1_SIZE_U)
	$oBMP.GetPixelSize($vSize)
	Local $iW = $vSize.Width, $iH = $vSize.Height
	$oClone.CopyFromBitmap(_D2D1_POINT_2U(0, 0), $oBMP, _D2D1_RECT_U(0, 0, $iW, $iH)) ; Das mit dem Klonen hat irgendwie nicht geklappt.
	Local $iX = Int($dx / $iW) * $iW + $dx, $iY = Int($dy / $iH) * $iH + $dy, $tX = $dx < 0 ? $iW : -$iW, $tY = $dy < 0 ? $iH : -$iH
	$oBMP.CopyFromBitmap(_D2D1_POINT_2U(Max($iX, 0), Max($iY, 0)), $oClone, _D2D1_RECT_U(Max(-$iX, 0), Max(-$iY, 0), $iW, $iH))
	$oBMP.CopyFromBitmap(_D2D1_POINT_2U(Max($iX + $tX, 0), Max($iY, 0)), $oClone, _D2D1_RECT_U(Max(-($iX + $tX), 0), Max(-$iY, 0), $iW, $iH))
	$oBMP.CopyFromBitmap(_D2D1_POINT_2U(Max($iX, 0), Max($iY + $tY, 0)), $oClone, _D2D1_RECT_U(Max(-$iX, 0), Max(-($iY + $tY), 0), $iW, $iH))
	$oBMP.CopyFromBitmap(_D2D1_POINT_2U(Max($iX + $tX, 0), Max($iY + $tY, 0)), $oClone, _D2D1_RECT_U(Max(-($iX + $tX), 0), Max(-($iY + $tY), 0), $iW, $iH))
EndFunc